.nolist
include \masm32\include\masm32rt.inc
.686
.xmm
include \masm32\macros\timers.asm

LOOP_COUNT	= 10000000
RepCt	= 1
RepCt2	= 32

.data
MainString	db "This is a long string meant for testing the SSE2 instructions"
	db "This is a long string meant for testing the SSE2 instructions"
	db "This is a long string meant for testing the SSE2 instructions"
	db "This is a long string meant for testing the SSE2 instructions"
	db "This is a long string meant for testing the SSE2 instructions"
	db "This is a long string meant for testing the SSE2 instructions"
	db "This is a long string meant for testing the SSE2 instructions", 0
align 16
qw4mov	dq 1234567890123456h, 1234567890123456h
	db 1, 2, 3, 4, 5, 6, 7
qw4movU	dq 1234567890123456h, 1234567890123456h

.code
start:
	print chr$("Aligned, mem to xmm:", 13, 10)
	
	REPEAT RepCt
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		mov esi, offset MainString
		REPEAT RepCt2
			movaps xmm0, [esi]
			movaps xmm1, [esi+16]
			movaps xmm2, [esi+32]
			movaps xmm3, [esi+48]
		ENDM
	counter_end
	shr eax, 5	; /32
	print str$(eax), 9, "cycles for 4* movaps ", 13, 10
	ENDM

	REPEAT RepCt
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		mov esi, offset MainString
		REPEAT RepCt2
			movapd xmm0, [esi]
			movapd xmm1, [esi+16]
			movapd xmm2, [esi+32]
			movapd xmm3, [esi+48]
		ENDM
	counter_end
	shr eax, 5	; /32
	print str$(eax), 9, "cycles for 4* movapd ", 13, 10
	ENDM

	REPEAT RepCt
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		mov esi, offset MainString
		REPEAT RepCt2
			movdqa xmm0, [esi]
			movdqa xmm1, [esi+16]
			movdqa xmm2, [esi+32]
			movdqa xmm3, [esi+48]
		ENDM
	counter_end
	shr eax, 5	; /32
	print str$(eax), 9, "cycles for 4* movdqa", 13, 10
	ENDM

	print chr$(13, 10, "Unaligned, mem to xmm:", 13, 10)
	
	REPEAT RepCt
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		lea esi, MainString+7
		REPEAT RepCt2
			movups xmm0, [esi]
			movups xmm1, [esi+16]
			movups xmm2, [esi+32]
			movups xmm3, [esi+48]
		ENDM
	counter_end
	shr eax, 5	; /32
	print str$(eax), 9, "cycles for 4* movups ", 13, 10
	ENDM

	REPEAT RepCt
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		lea esi, MainString+7
		REPEAT RepCt2
			movupd xmm0, [esi]
			movupd xmm1, [esi+16]
			movupd xmm2, [esi+32]
			movupd xmm3, [esi+48]
		ENDM
	counter_end
	shr eax, 5	; /32
	print str$(eax), 9, "cycles for 4* movupd ", 13, 10
	ENDM

	REPEAT RepCt
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		lea esi, MainString+7
		REPEAT RepCt2
			movdqu xmm0, [esi]
			movdqu xmm1, [esi+16]
			movdqu xmm2, [esi+32]
			movdqu xmm3, [esi+48]
		ENDM
	counter_end
	shr eax, 5	; /32
	print str$(eax), 9, "cycles for 4* movdqu", 13, 10
	ENDM

	print chr$(13, 10, "Aligned, xmm to xmm:", 13, 10)
	REPEAT RepCt
	mov eax, 12345678h
	movd xmm0, eax
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		REPEAT RepCt2
			movaps xmm1, xmm0
			movaps xmm2, xmm1
			movaps xmm3, xmm2
			movaps xmm0, xmm3
		ENDM
	counter_end
	shr eax, 5	; /32
	print str$(eax), 9, "cycles for 4* movaps ", 13, 10
	ENDM

	REPEAT RepCt
	mov eax, 12345678h
	movd xmm0, eax
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		REPEAT RepCt2
			movapd xmm1, xmm0
			movapd xmm2, xmm1
			movapd xmm3, xmm2
			movapd xmm0, xmm3
		ENDM
	counter_end
	shr eax, 5	; /32
	print str$(eax), 9, "cycles for 4* movapd ", 13, 10
	ENDM

	REPEAT RepCt
	mov eax, 12345678h
	movd xmm0, eax
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		REPEAT RepCt2
			movdqa xmm1, xmm0
			movdqa xmm2, xmm1
			movdqa xmm3, xmm2
			movdqa xmm0, xmm3
		ENDM
	counter_end
	shr eax, 5	; /32
	print str$(eax), 9, "cycles for 4* movdqa", 13, 10
	ENDM

	print chr$(13, 10, "Aligned, xmm to MEM to xmm:", 13, 10)
	REPEAT RepCt
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		mov esi, offset qw4mov
		REPEAT RepCt2
			movaps [esi], xmm0
			movaps xmm1, [esi]
			movaps [esi], xmm1
			movaps xmm2, [esi]
			movaps [esi], xmm2
			movaps xmm3, [esi]
			movaps [esi], xmm3
			movaps xmm4, [esi]
		ENDM
	counter_end
	shr eax, 5	; /32
	print str$(eax), 9, "cycles for 4* movaps ", 13, 10
	ENDM

	REPEAT RepCt
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		mov esi, offset qw4mov
		REPEAT RepCt2
			movapd  [esi], xmm0
			movapd  xmm1, [esi]
			movapd  [esi], xmm1
			movapd  xmm2, [esi]
			movapd  [esi], xmm2
			movapd  xmm3, [esi]
			movapd  [esi], xmm3
			movapd  xmm4, [esi]
		ENDM
	counter_end
	shr eax, 5	; /32
	print str$(eax), 9, "cycles for 4* movapd  ", 13, 10
	ENDM

	REPEAT RepCt
	mov eax, 12345678h
	movd xmm0, eax
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		REPEAT RepCt2
			movdqa [esi], xmm0
			movdqa xmm1, [esi]
			movdqa [esi], xmm1
			movdqa xmm2, [esi]
			movdqa [esi], xmm2
			movdqa xmm3, [esi]
			movdqa [esi], xmm3
			movdqa xmm4, [esi]
		ENDM
	counter_end
	shr eax, 5	; /32
	print str$(eax), 9, "cycles for 4* movdqa", 13, 10
	ENDM

	print chr$(13, 10, "Unaligned, xmm to MEM to xmm:", 13, 10)
	REPEAT RepCt
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		mov esi, offset qw4movU
		REPEAT RepCt2
			movups [esi], xmm0
			movups xmm1, [esi]
			movups [esi], xmm1
			movups xmm2, [esi]
			movups [esi], xmm2
			movups xmm3, [esi]
			movups [esi], xmm3
			movups xmm4, [esi]
		ENDM
	counter_end
	shr eax, 5	; /32
	print str$(eax), 9, "cycles for 4* movups ", 13, 10
	ENDM

	REPEAT RepCt
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		mov esi, offset qw4movU
		REPEAT RepCt2
			movupd  [esi], xmm0
			movupd  xmm1, [esi]
			movupd  [esi], xmm1
			movupd  xmm2, [esi]
			movupd  [esi], xmm2
			movupd  xmm3, [esi]
			movupd  [esi], xmm3
			movupd  xmm4, [esi]
		ENDM
	counter_end
	shr eax, 5	; /32
	print str$(eax), 9, "cycles for 4* movupd  ", 13, 10
	ENDM

	REPEAT RepCt
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		mov esi, offset qw4movU
		REPEAT RepCt2
			movdqu [esi], xmm0
			movdqu xmm1, [esi]
			movdqu [esi], xmm1
			movdqu xmm2, [esi]
			movdqu [esi], xmm2
			movdqu xmm3, [esi]
			movdqu [esi], xmm3
			movdqu xmm4, [esi]
		ENDM
	counter_end
	shr eax, 5	; /32
	print str$(eax), 9, "cycles for 4* movdqu", 13, 10
	ENDM

	print chr$(10, "Unaligned, xmm to xmm (theoretical case):", 13, 10)

	REPEAT RepCt
	mov eax, 12345678h
	movd xmm0, eax
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		REPEAT RepCt2
			movups xmm1, xmm0
			movups xmm2, xmm1
			movups xmm3, xmm2
			movups xmm0, xmm3
		ENDM
	counter_end
	shr eax, 5	; /32
	print str$(eax), 9, "cycles for 4* movups", 13, 10
	ENDM

	REPEAT RepCt
	mov eax, 12345678h
	movd xmm0, eax
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		REPEAT RepCt2
			movupd xmm1, xmm0
			movupd xmm2, xmm1
			movupd xmm3, xmm2
			movupd xmm0, xmm3
		ENDM
	counter_end
	shr eax, 5	; /32
	print str$(eax), 9, "cycles for 4* movupd", 13, 10
	ENDM

	REPEAT RepCt
	mov eax, 12345678h
	movd xmm0, eax
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		REPEAT RepCt2
			movdqu xmm1, xmm0
			movdqu xmm2, xmm1
			movdqu xmm3, xmm2
			movdqu xmm0, xmm3
		ENDM
	counter_end
	shr eax, 5	; /32
	print str$(eax), 9, "cycles for 4* movdqu", 13, 10
	ENDM

	inkey "--- ok ---"
	exit
end start
OPT_Tmp2Asm	1
OPT_Assembler	ml
OPT_Wait	0

Celeron M:
Aligned, mem to xmm:
7       cycles for 4* movaps
7       cycles for 4* movapd
7       cycles for 4* movdqa

Unaligned, mem to xmm:
13      cycles for 4* movups
13      cycles for 4* movupd
13      cycles for 4* movdqu

Aligned, xmm to xmm:
4       cycles for 4* movaps
4       cycles for 4* movapd
4       cycles for 4* movdqa

Aligned, xmm to MEM to xmm:
15      cycles for 4* movaps
15      cycles for 4* movapd
15      cycles for 4* movdqa

Unaligned, xmm to MEM to xmm:
52      cycles for 4* movups
52      cycles for 4* movupd
52      cycles for 4* movdqu

Unaligned, xmm to xmm (theoretical case):
4       cycles for 4* movups
4       cycles for 4* movupd
4       cycles for 4* movdqu

Prescott P4:
Aligned, mem to xmm:
4       cycles for 4* movaps
3       cycles for 4* movapd
3       cycles for 4* movdqa

Unaligned, mem to xmm:
25      cycles for 4* movups
26      cycles for 4* movupd
25      cycles for 4* movdqu

Aligned, xmm to xmm:
27      cycles for 4* movaps
27      cycles for 4* movapd
27      cycles for 4* movdqa

Aligned, xmm to MEM to xmm:
17      cycles for 4* movaps
17      cycles for 4* movapd
17      cycles for 4* movdqa

Unaligned, xmm to MEM to xmm:
43      cycles for 4* movups
43      cycles for 4* movupd
43      cycles for 4* movdqu

Unaligned, xmm to xmm (theoretical case):
27      cycles for 4* movups
27      cycles for 4* movupd
27      cycles for 4* movdqu

















